Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_ecckd_interface.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_ecckd_interface.F90	(revision 4489)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_ecckd_interface.F90	(revision 4489)
@@ -0,0 +1,278 @@
+! radiation_ecckd_interface.F90 - Interface to ecCKD gas optics model
+!
+! (C) Copyright 2020- ECMWF.
+!
+! This software is licensed under the terms of the Apache Licence Version 2.0
+! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+!
+! In applying this licence, ECMWF does not waive the privileges and immunities
+! granted to it by virtue of its status as an intergovernmental organisation
+! nor does it submit to any jurisdiction.
+!
+! Author:  Robin Hogan
+! Email:   r.j.hogan@ecmwf.int
+! License: see the COPYING file for details
+!
+
+module radiation_ecckd_interface
+
+  implicit none
+
+  public  :: setup_gas_optics, set_gas_units, gas_optics !, planck_function
+
+contains
+
+  !---------------------------------------------------------------------
+  ! Setup the ecCKD generalized gas optics model
+  subroutine setup_gas_optics(config)
+
+    use parkind1, only : jprb
+    use radiation_config
+
+    type(config_type), intent(inout), target :: config
+
+    integer :: jj
+    
+    if (config%do_sw) then
+
+      ! Read shortwave ecCKD gas optics NetCDF file
+      call config%gas_optics_sw%read(trim(config%gas_optics_sw_file_name), &
+           &                         config%iverbosesetup)
+
+      ! Copy over relevant properties
+      config%n_g_sw     = config%gas_optics_sw%ng
+
+      if (config%do_cloud_aerosol_per_sw_g_point) then
+        ! Bands and g points are the same
+        config%n_bands_sw = config%n_g_sw
+      else
+        ! Bands are groups of g points and span a continuous region of
+        ! wavenumber space
+        config%n_bands_sw = config%gas_optics_sw%spectral_def%nband
+      end if
+
+      allocate(config%i_band_from_g_sw          (config%n_g_sw))
+      allocate(config%i_band_from_reordered_g_sw(config%n_g_sw))
+      allocate(config%i_g_from_reordered_g_sw   (config%n_g_sw))
+        
+      if (config%do_cloud_aerosol_per_sw_g_point) then
+        config%i_band_from_g_sw           = [ (jj, jj = 1,config%n_g_sw) ]
+        config%i_band_from_reordered_g_sw = [ (jj, jj = 1,config%n_g_sw) ]
+      else
+        config%i_band_from_g_sw &
+             &  = config%gas_optics_sw%spectral_def%i_band_number
+        config%i_band_from_reordered_g_sw &
+             &  = config%gas_optics_sw%spectral_def%i_band_number
+      end if
+      config%i_g_from_reordered_g_sw      = [ (jj, jj = 1,config%n_g_sw) ]
+
+      if (config%iverbosesetup >= 2) then
+        call config%gas_optics_sw%print()
+      end if
+
+    end if
+
+    if (config%do_lw) then
+
+      ! Read longwave ecCKD gas optics NetCDF file
+      call config%gas_optics_lw%read(trim(config%gas_optics_lw_file_name), &
+           &                         config%iverbosesetup)
+
+      ! Copy over relevant properties
+      config%n_g_lw     = config%gas_optics_lw%ng
+
+      if (config%do_cloud_aerosol_per_lw_g_point) then
+        ! Bands and g points are the same
+        config%n_bands_lw = config%n_g_lw
+      else
+        ! Bands are groups of g points and span a continuous region of
+        ! wavenumber space
+        config%n_bands_lw = config%gas_optics_lw%spectral_def%nband
+      end if
+
+      allocate(config%i_band_from_g_lw          (config%n_g_lw))
+      allocate(config%i_band_from_reordered_g_lw(config%n_g_lw))
+      allocate(config%i_g_from_reordered_g_lw   (config%n_g_lw))
+
+      if (config%do_cloud_aerosol_per_lw_g_point) then
+        config%i_band_from_g_lw           = [ (jj, jj = 1,config%n_g_lw) ]
+        config%i_band_from_reordered_g_lw = [ (jj, jj = 1,config%n_g_lw) ]
+      else
+        config%i_band_from_g_lw &
+             &  = config%gas_optics_lw%spectral_def%i_band_number
+        config%i_band_from_reordered_g_lw &
+             &  = config%gas_optics_lw%spectral_def%i_band_number
+      end if
+      config%i_g_from_reordered_g_lw      = [ (jj, jj = 1,config%n_g_lw) ]
+
+      if (config%iverbosesetup >= 2) then
+        call config%gas_optics_lw%print()
+      end if
+
+    end if
+
+    ! The i_spec_* variables are used solely for storing spectral
+    ! data, and this can either be by band or by g-point
+    if (config%do_save_spectral_flux) then
+      if (config%do_save_gpoint_flux) then
+        config%n_spec_sw = config%n_g_sw
+        config%n_spec_lw = config%n_g_lw
+        config%i_spec_from_reordered_g_sw => config%i_g_from_reordered_g_sw
+        config%i_spec_from_reordered_g_lw => config%i_g_from_reordered_g_lw
+      else
+        config%n_spec_sw = config%n_bands_sw
+        config%n_spec_lw = config%n_bands_lw
+        config%i_spec_from_reordered_g_sw => config%i_band_from_reordered_g_sw
+        config%i_spec_from_reordered_g_lw => config%i_band_from_reordered_g_lw
+      end if
+    else
+      config%n_spec_sw = 0
+      config%n_spec_lw = 0
+      nullify(config%i_spec_from_reordered_g_sw)
+      nullify(config%i_spec_from_reordered_g_lw)
+    end if
+
+  end subroutine setup_gas_optics
+
+
+  !---------------------------------------------------------------------
+  ! Scale gas mixing ratios according to required units
+  subroutine set_gas_units(gas)
+
+    use radiation_gas,           only : gas_type, IVolumeMixingRatio
+    type(gas_type),    intent(inout) :: gas
+
+    call gas%set_units(IVolumeMixingRatio)
+
+  end subroutine set_gas_units
+
+
+  !---------------------------------------------------------------------
+  ! Compute gas optical depths, shortwave scattering, Planck function
+  ! and incoming shortwave radiation at top-of-atmosphere
+  subroutine gas_optics(ncol,nlev,istartcol,iendcol, &
+       &  config, single_level, thermodynamics, gas, & 
+       &  od_lw, od_sw, ssa_sw, lw_albedo, planck_hl, lw_emission, &
+       &  incoming_sw)
+
+    use parkind1, only : jprb
+    use radiation_config,         only : config_type
+    use radiation_thermodynamics, only : thermodynamics_type
+    use radiation_single_level,   only : single_level_type
+    use radiation_gas_constants,  only : NMaxGases
+    use radiation_gas
+
+    integer,                  intent(in) :: ncol               ! number of columns
+    integer,                  intent(in) :: nlev               ! number of levels
+    integer,                  intent(in) :: istartcol, iendcol ! range of cols to process
+    type(config_type),        intent(in) :: config
+    type(single_level_type),  intent(in) :: single_level
+    type(thermodynamics_type),intent(in) :: thermodynamics
+    type(gas_type),           intent(in) :: gas
+
+    ! Longwave albedo of the surface
+    real(jprb), dimension(config%n_g_lw,istartcol:iendcol), &
+         &  intent(in), optional :: lw_albedo
+
+    ! Gaseous layer optical depth in longwave and shortwave, and
+    ! shortwave single scattering albedo (i.e. fraction of extinction
+    ! due to Rayleigh scattering) at each g-point
+    real(jprb), dimension(config%n_g_lw,nlev,istartcol:iendcol), intent(out) :: &
+         &   od_lw
+    real(jprb), dimension(config%n_g_sw,nlev,istartcol:iendcol), intent(out) :: &
+         &   od_sw, ssa_sw
+
+    ! The Planck function (emitted flux from a black body) at half
+    ! levels at each longwave g-point
+    real(jprb), dimension(config%n_g_lw,nlev+1,istartcol:iendcol), &
+         &   intent(out), optional :: planck_hl
+    ! Planck function for the surface (W m-2)
+    real(jprb), dimension(config%n_g_lw,istartcol:iendcol), &
+         &   intent(out), optional :: lw_emission
+
+    ! The incoming shortwave flux into a plane perpendicular to the
+    ! incoming radiation at top-of-atmosphere in each of the shortwave
+    ! g-points
+    real(jprb), dimension(config%n_g_sw,istartcol:iendcol), &
+         &   intent(out), optional :: incoming_sw
+
+    ! Temperature at full levels (K)
+    real(jprb) :: temperature_fl(istartcol:iendcol,nlev)
+
+    integer :: jcol
+
+    !temperature_fl(istartcol:iendcol,:) &
+    !     &  = 0.5_jprb * (thermodynamics%temperature_hl(istartcol:iendcol,1:nlev) &
+    !     &               +thermodynamics%temperature_hl(istartcol:iendcol,2:nlev+1))
+ 
+    temperature_fl(istartcol:iendcol,:) &
+         &  = (thermodynamics%temperature_hl(istartcol:iendcol,1:nlev) &
+         &     *thermodynamics%pressure_hl(istartcol:iendcol,1:nlev) &
+         &    +thermodynamics%temperature_hl(istartcol:iendcol,2:nlev+1) &
+         &     *thermodynamics%pressure_hl(istartcol:iendcol,2:nlev+1)) &
+         &  / (thermodynamics%pressure_hl(istartcol:iendcol,1:nlev) &
+         &    +thermodynamics%pressure_hl(istartcol:iendcol,2:nlev+1))
+ 
+    if (config%do_sw) then
+
+      call config%gas_optics_sw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+           &  NMaxGases, thermodynamics%pressure_hl, &
+           &  temperature_fl, &
+           &  gas%mixing_ratio, &
+!           &  reshape(gas%mixing_ratio(istartcol:iendcol,:,:), &
+!           &          [nlev,iendcol-istartcol+1,NMaxGases],order=[2,1,3]), &
+           &  od_sw, rayleigh_od_fl=ssa_sw)
+      ! At this point od_sw = absorption optical depth and ssa_sw =
+      ! rayleigh optical depth: convert to total optical depth and
+      ! single-scattering albedo
+      od_sw = od_sw + ssa_sw
+      ssa_sw = ssa_sw / od_sw
+
+      if (present(incoming_sw)) then
+        call config%gas_optics_sw%calc_incoming_sw(single_level%solar_irradiance, incoming_sw)
+      end if
+
+    end if
+
+    if (config%do_lw) then
+
+      call config%gas_optics_lw%calc_optical_depth(ncol,nlev,istartcol,iendcol, &
+           &  NMaxGases, thermodynamics%pressure_hl, &
+           &  temperature_fl, &
+           &  gas%mixing_ratio, &
+!           &  reshape(gas%mixing_ratio(istartcol:iendcol,:,:), &
+!           &          [nlev,iendcol-istartcol+1,NMaxGases],order=[2,1,3]), &
+           &  od_lw)
+
+      ! Calculate the Planck function for each g point
+      do jcol = istartcol,iendcol
+        call config%gas_optics_lw%calc_planck_function(nlev+1, &
+             &  thermodynamics%temperature_hl(jcol,:), planck_hl(:,:,jcol))
+      end do
+      call config%gas_optics_lw%calc_planck_function(iendcol+1-istartcol, &
+           &  single_level%skin_temperature(istartcol:iendcol), &
+           &  lw_emission(:,:))
+      lw_emission = lw_emission * (1.0_jprb - lw_albedo)
+
+    end if
+
+  end subroutine gas_optics
+
+  ! !---------------------------------------------------------------------
+  ! ! Externally facing function for computing the Planck function
+  ! ! without reference to any gas profile; typically this would be used
+  ! ! for computing the emission by a surface.
+  ! subroutine planck_function(config, temperature, planck_surf)
+
+  !   use parkind1,                 only : jprb
+  !   use radiation_config,         only : config_type
+
+  !   type(config_type), intent(in) :: config
+  !   real(jprb),        intent(in) :: temperature
+
+  !   ! Planck function of the surface (W m-2)
+  !   real(jprb), dimension(config%n_g_lw), intent(out) :: planck_surf
+
+  ! end subroutine planck_function
+
+end module radiation_ecckd_interface
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_flux.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_flux.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_flux.F90	(revision 4489)
@@ -100,4 +100,11 @@
   end type flux_type
 
+! Added for DWD (2020)
+#ifdef __SX__
+      logical, parameter :: use_indexed_sum_vec = .true.
+#else
+      logical, parameter :: use_indexed_sum_vec = .false.
+#endif
+
 contains
 
@@ -132,5 +139,5 @@
         if (config%n_spec_lw == 0) then
           write(nulerr,'(a)') '*** Error: number of LW spectral points to save not yet defined ' &
-               & // 'so cannot allocated spectral flux arrays'
+               & // 'so cannot allocate spectral flux arrays'
           call radiation_abort()
         end if
@@ -321,4 +328,11 @@
     end if
 
+    if (allocated(this%lw_dn_surf_g))               deallocate(this%lw_dn_surf_g)
+    if (allocated(this%lw_dn_surf_clear_g))         deallocate(this%lw_dn_surf_clear_g)
+    if (allocated(this%sw_dn_diffuse_surf_g))       deallocate(this%sw_dn_diffuse_surf_g)
+    if (allocated(this%sw_dn_direct_surf_g))        deallocate(this%sw_dn_direct_surf_g)
+    if (allocated(this%sw_dn_diffuse_surf_clear_g)) deallocate(this%sw_dn_diffuse_surf_clear_g)
+    if (allocated(this%sw_dn_direct_surf_clear_g))  deallocate(this%sw_dn_direct_surf_clear_g)
+
     if (lhook) call dr_hook('radiation_flux:deallocate',1,hook_handle)
 
@@ -349,28 +363,56 @@
     if (config%do_sw .and. config%do_surface_sw_spectral_flux) then
 
-      do jcol = istartcol,iendcol
-        call indexed_sum(this%sw_dn_direct_surf_g(:,jcol), &
-             &           config%i_band_from_reordered_g_sw, &
-             &           this%sw_dn_direct_surf_band(:,jcol))
-        call indexed_sum(this%sw_dn_diffuse_surf_g(:,jcol), &
-             &           config%i_band_from_reordered_g_sw, &
-             &           this%sw_dn_surf_band(:,jcol))
-        this%sw_dn_surf_band(:,jcol) &
-             &  = this%sw_dn_surf_band(:,jcol) &
-             &  + this%sw_dn_direct_surf_band(:,jcol)
-      end do
+      if (use_indexed_sum_vec) then
+        call indexed_sum_vec(this%sw_dn_direct_surf_g, &
+             &               config%i_band_from_reordered_g_sw, &
+             &               this%sw_dn_direct_surf_band, istartcol, iendcol)
+        call indexed_sum_vec(this%sw_dn_diffuse_surf_g, &
+             &               config%i_band_from_reordered_g_sw, &
+             &               this%sw_dn_surf_band, istartcol, iendcol)
+        do jcol = istartcol,iendcol
+          this%sw_dn_surf_band(:,jcol) &
+               &  = this%sw_dn_surf_band(:,jcol) &
+               &  + this%sw_dn_direct_surf_band(:,jcol)
+        end do
+      else
+        do jcol = istartcol,iendcol
+          call indexed_sum(this%sw_dn_direct_surf_g(:,jcol), &
+               &           config%i_band_from_reordered_g_sw, &
+               &           this%sw_dn_direct_surf_band(:,jcol))
+          call indexed_sum(this%sw_dn_diffuse_surf_g(:,jcol), &
+               &           config%i_band_from_reordered_g_sw, &
+               &           this%sw_dn_surf_band(:,jcol))
+          this%sw_dn_surf_band(:,jcol) &
+               &  = this%sw_dn_surf_band(:,jcol) &
+               &  + this%sw_dn_direct_surf_band(:,jcol)
+        end do
+      end if
 
       if (config%do_clear) then
-        do jcol = istartcol,iendcol
-          call indexed_sum(this%sw_dn_direct_surf_clear_g(:,jcol), &
-               &           config%i_band_from_reordered_g_sw, &
-               &           this%sw_dn_direct_surf_clear_band(:,jcol))
-          call indexed_sum(this%sw_dn_diffuse_surf_clear_g(:,jcol), &
-               &           config%i_band_from_reordered_g_sw, &
-               &           this%sw_dn_surf_clear_band(:,jcol))
-          this%sw_dn_surf_clear_band(:,jcol) &
-               &  = this%sw_dn_surf_clear_band(:,jcol) &
-               &  + this%sw_dn_direct_surf_clear_band(:,jcol)
-        end do
+        if (use_indexed_sum_vec) then
+          call indexed_sum_vec(this%sw_dn_direct_surf_clear_g, &
+               &               config%i_band_from_reordered_g_sw, &
+               &               this%sw_dn_direct_surf_clear_band, istartcol, iendcol)
+          call indexed_sum_vec(this%sw_dn_diffuse_surf_clear_g, &
+               &               config%i_band_from_reordered_g_sw, &
+               &               this%sw_dn_surf_clear_band, istartcol, iendcol)
+          do jcol = istartcol,iendcol
+            this%sw_dn_surf_clear_band(:,jcol) &
+                 &  = this%sw_dn_surf_clear_band(:,jcol) &
+                 &  + this%sw_dn_direct_surf_clear_band(:,jcol)
+          end do
+        else
+          do jcol = istartcol,iendcol
+            call indexed_sum(this%sw_dn_direct_surf_clear_g(:,jcol), &
+                 &           config%i_band_from_reordered_g_sw, &
+                 &           this%sw_dn_direct_surf_clear_band(:,jcol))
+            call indexed_sum(this%sw_dn_diffuse_surf_clear_g(:,jcol), &
+                 &           config%i_band_from_reordered_g_sw, &
+                 &           this%sw_dn_surf_clear_band(:,jcol))
+            this%sw_dn_surf_clear_band(:,jcol) &
+                 &  = this%sw_dn_surf_clear_band(:,jcol) &
+                 &  + this%sw_dn_direct_surf_clear_band(:,jcol)
+          end do
+        end if
       end if
 
@@ -383,12 +425,21 @@
         this%sw_dn_direct_surf_canopy (:,istartcol:iendcol) = this%sw_dn_direct_surf_g (:,istartcol:iendcol)
       else if (config%do_nearest_spectral_sw_albedo) then
-        do jcol = istartcol,iendcol
-          call indexed_sum(this%sw_dn_direct_surf_g(:,jcol), &
-               &           config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
-               &           this%sw_dn_direct_surf_canopy(:,jcol))
-          call indexed_sum(this%sw_dn_diffuse_surf_g(:,jcol), &
-               &           config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
-               &           this%sw_dn_diffuse_surf_canopy(:,jcol))
-        end do
+        if (use_indexed_sum_vec) then
+          call indexed_sum_vec(this%sw_dn_direct_surf_g, &
+               &               config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
+               &               this%sw_dn_direct_surf_canopy, istartcol, iendcol)
+          call indexed_sum_vec(this%sw_dn_diffuse_surf_g, &
+               &               config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
+               &               this%sw_dn_diffuse_surf_canopy, istartcol, iendcol)
+        else
+          do jcol = istartcol,iendcol
+            call indexed_sum(this%sw_dn_direct_surf_g(:,jcol), &
+                 &           config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
+                 &           this%sw_dn_direct_surf_canopy(:,jcol))
+            call indexed_sum(this%sw_dn_diffuse_surf_g(:,jcol), &
+                 &           config%i_albedo_from_band_sw(config%i_band_from_reordered_g_sw), &
+                 &           this%sw_dn_diffuse_surf_canopy(:,jcol))
+          end do
+        end if
       else
         ! More accurate calculations using weights, but requires
@@ -425,17 +476,29 @@
         this%lw_dn_surf_canopy(:,istartcol:iendcol) = this%lw_dn_surf_g(:,istartcol:iendcol)
       else if (config%do_nearest_spectral_lw_emiss) then
-        do jcol = istartcol,iendcol
-          call indexed_sum(this%lw_dn_surf_g(:,jcol), &
-               &           config%i_emiss_from_band_lw(config%i_band_from_reordered_g_lw), &
-               &           this%lw_dn_surf_canopy(:,jcol))
-        end do
+        if (use_indexed_sum_vec) then
+          call indexed_sum_vec(this%lw_dn_surf_g, &
+               &               config%i_emiss_from_band_lw(config%i_band_from_reordered_g_lw), &
+               &               this%lw_dn_surf_canopy, istartcol, iendcol)
+        else
+          do jcol = istartcol,iendcol
+            call indexed_sum(this%lw_dn_surf_g(:,jcol), &
+                 &           config%i_emiss_from_band_lw(config%i_band_from_reordered_g_lw), &
+                 &           this%lw_dn_surf_canopy(:,jcol))
+          end do
+        end if
       else
         ! Compute fluxes in each longwave emissivity interval using
         ! weights; first sum over g points to get the values in bands
-        do jcol = istartcol,iendcol
-          call indexed_sum(this%lw_dn_surf_g(:,jcol), &
-               &           config%i_band_from_reordered_g_lw, &
-               &           lw_dn_surf_band(:,jcol))
-        end do
+        if (use_indexed_sum_vec) then
+          call indexed_sum_vec(this%lw_dn_surf_g, &
+               &               config%i_band_from_reordered_g_lw, &
+               &               lw_dn_surf_band, istartcol, iendcol)
+        else
+          do jcol = istartcol,iendcol
+            call indexed_sum(this%lw_dn_surf_g(:,jcol), &
+                 &           config%i_band_from_reordered_g_lw, &
+                 &           lw_dn_surf_band(:,jcol))
+          end do
+        end if
         nalbedoband = size(config%lw_emiss_weights,1)
         this%lw_dn_surf_canopy(:,istartcol:iendcol) = 0.0_jprb
@@ -465,5 +528,5 @@
 
     use yomhook,          only : lhook, dr_hook
-    use radiation_config, only : out_of_bounds_2d
+    use radiation_check,  only : out_of_bounds_2d
 
     class(flux_type), intent(inout) :: this
@@ -497,5 +560,5 @@
   function heating_rate_out_of_physical_bounds(this, nlev, istartcol, iendcol, pressure_hl) result(is_bad)
     
-    use radiation_config, only : out_of_bounds_2d
+    use radiation_check, only : out_of_bounds_2d
     use radiation_constants, only : AccelDueToGravity
 
@@ -581,4 +644,25 @@
   end subroutine indexed_sum
 
+  !---------------------------------------------------------------------
+  ! Vectorized version of "add_indexed_sum"
+  subroutine indexed_sum_vec(source, ind, dest, ist, iend)
+
+    real(jprb), intent(in)  :: source(:,:)
+    integer,    intent(in)  :: ind(:)
+    real(jprb), intent(out) :: dest(:,:)
+    integer,    intent(in)  :: ist, iend
+
+    integer :: ig, jg, jc
+
+    dest = 0.0
+
+    do jg = lbound(source,1), ubound(source,1)
+      ig = ind(jg)
+      do jc = ist, iend
+        dest(ig,jc) = dest(ig,jc) + source(jg,jc)
+      end do
+    end do
+
+  end subroutine indexed_sum_vec
 
   !---------------------------------------------------------------------
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas.F90	(revision 4489)
@@ -19,49 +19,8 @@
 
   use parkind1, only : jprb
+  use radiation_gas_constants
 
   implicit none
   public
-
-  ! Gas codes; these indices match those of RRTM-LW up to 7
-  integer, parameter :: IGasNotPresent = 0
-  integer, parameter :: IH2O   = 1
-  integer, parameter :: ICO2   = 2
-  integer, parameter :: IO3    = 3
-  integer, parameter :: IN2O   = 4
-  integer, parameter :: ICO    = 5
-  integer, parameter :: ICH4   = 6
-  integer, parameter :: IO2    = 7
-  integer, parameter :: ICFC11 = 8
-  integer, parameter :: ICFC12 = 9
-  integer, parameter :: IHCFC22= 10
-  integer, parameter :: ICCl4  = 11 
-  integer, parameter :: INO2   = 12
-  integer, parameter :: NMaxGases = 12
-
-  ! Molar masses (g mol-1) of dry air and the various gases above
-  real(jprb), parameter :: IAirMolarMass = 28.970
-  real(jprb), parameter, dimension(0:NMaxGases) :: IGasMolarMass = (/ &
-       & 0.0_jprb,        & ! Gas not present
-       & 18.0152833_jprb, & ! H2O
-       & 44.011_jprb,     & ! CO2
-       & 47.9982_jprb,    & ! O3
-       & 44.013_jprb,     & ! N2O
-       & 28.0101_jprb,    & ! CO
-       & 16.043_jprb,     & ! CH4
-       & 31.9988_jprb,    & ! O2
-       & 137.3686_jprb,   & ! CFC11
-       & 120.914_jprb,    & ! CFC12
-       & 86.469_jprb,     & ! HCFC22
-       & 153.823_jprb,    & ! CCl4    
-       & 46.0055_jprb /)    ! NO2
-
-  ! The corresponding names of the gases in upper and lower case, used
-  ! for reading variables from the input file
-  character*6, dimension(NMaxGases), parameter :: GasName &
-       &  = (/'H2O   ','CO2   ','O3    ','N2O   ','CO    ','CH4   ', &
-       &      'O2    ','CFC11 ','CFC12 ','HCFC22','CCl4  ','NO2   '/)
-  character*6, dimension(NMaxGases), parameter :: GasLowerCaseName &
-       &  = (/'h2o   ','co2   ','o3    ','n2o   ','co    ','ch4   ', &
-       &      'o2    ','cfc11 ','cfc12 ','hcfc22','ccl4  ','no2   '/)
 
   ! Available units
@@ -121,4 +80,6 @@
 
   !---------------------------------------------------------------------
+  ! Allocate a derived type for holding gas mixing ratios given the
+  ! number of columns and levels
   subroutine allocate_gas(this, ncol, nlev)
 
@@ -191,5 +152,6 @@
     integer,    optional, intent(in)    :: istartcol
 
-    integer :: i1, i2
+    integer :: i1, i2, jc, jk
+
 
     real(jprb)                          :: hook_handle
@@ -245,6 +207,10 @@
     this%iunits(igas) = iunits
     this%is_well_mixed(igas) = .false.
-    this%mixing_ratio(i1:i2,:,igas) = mixing_ratio
-
+
+    do jk = 1,this%nlev
+      do jc = i1,i2
+        this%mixing_ratio(jc,jk,igas) = mixing_ratio(jc-i1+1,jk)
+      end do
+    end do
     if (present(scale_factor)) then
       this%scale_factor(igas) = scale_factor
@@ -276,5 +242,5 @@
     real(jprb)                          :: hook_handle
 
-    integer :: i1, i2
+    integer :: i1, i2, jc, jk
 
     if (lhook) call dr_hook('radiation_gas:put_well_mixed',0,hook_handle)
@@ -326,6 +292,10 @@
     this%iunits(igas)                  = iunits
     this%is_well_mixed(igas)           = .true.
-    this%mixing_ratio(i1:i2,:,igas)    = mixing_ratio
-
+
+    do jk = 1,this%nlev
+      do jc = i1,i2
+        this%mixing_ratio(jc,jk,igas) = mixing_ratio
+      end do
+    end do
     if (present(scale_factor)) then
       this%scale_factor(igas) = scale_factor
@@ -344,5 +314,4 @@
   ! immediately, but changes the scale factor for the specified gas,
   ! ready to be used in set_units_gas.
-
   subroutine scale_gas(this, igas, scale_factor, lverbose)
 
@@ -411,8 +380,8 @@
         if (iunits == IMassMixingRatio &
              &   .and. this%iunits(igas) == IVolumeMixingRatio) then
-          sf = sf * IGasMolarMass(igas) / IAirMolarMass
+          sf = sf * GasMolarMass(igas) / AirMolarMass
         else if (iunits == IVolumeMixingRatio &
              &   .and. this%iunits(igas) == IMassMixingRatio) then
-          sf = sf * IAirMolarMass / IGasMolarMass(igas)
+          sf = sf * AirMolarMass / GasMolarMass(igas)
         end if
         sf = sf * this%scale_factor(igas)
@@ -538,8 +507,8 @@
       if (iunits == IMassMixingRatio &
            &   .and. this%iunits(igas) == IVolumeMixingRatio) then
-        sf = sf * IGasMolarMass(igas) / IAirMolarMass
+        sf = sf * GasMolarMass(igas) / AirMolarMass
       else if (iunits == IVolumeMixingRatio &
            &   .and. this%iunits(igas) == IMassMixingRatio) then
-        sf = sf * IAirMolarMass / IGasMolarMass(igas)
+        sf = sf * AirMolarMass / GasMolarMass(igas)
       end if
       sf = sf * this%scale_factor(igas)
@@ -591,5 +560,5 @@
 
     use yomhook,          only : lhook, dr_hook
-    use radiation_config, only : out_of_bounds_3d
+    use radiation_check,  only : out_of_bounds_3d
 
     class(gas_type),   intent(inout) :: this
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas_constants.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas_constants.F90	(revision 4489)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_gas_constants.F90	(revision 4489)
@@ -0,0 +1,67 @@
+! radiation_gas_constants.F90 - Molar mases and ID codes of the various gases
+!
+! (C) Copyright 2014- ECMWF.
+!
+! This software is licensed under the terms of the Apache Licence Version 2.0
+! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+!
+! In applying this licence, ECMWF does not waive the privileges and immunities
+! granted to it by virtue of its status as an intergovernmental organisation
+! nor does it submit to any jurisdiction.
+!
+! Author:  Robin Hogan
+! Email:   r.j.hogan@ecmwf.int
+! License: see the COPYING file for details
+!
+
+module radiation_gas_constants
+
+  use parkind1, only : jprb
+
+  implicit none
+
+  public
+
+  ! Gas codes; these indices match those of RRTM-LW up to 7
+  integer, parameter :: IGasNotPresent = 0
+  integer, parameter :: IH2O   = 1
+  integer, parameter :: ICO2   = 2
+  integer, parameter :: IO3    = 3
+  integer, parameter :: IN2O   = 4
+  integer, parameter :: ICO    = 5
+  integer, parameter :: ICH4   = 6
+  integer, parameter :: IO2    = 7
+  integer, parameter :: ICFC11 = 8
+  integer, parameter :: ICFC12 = 9
+  integer, parameter :: IHCFC22= 10
+  integer, parameter :: ICCl4  = 11 
+  integer, parameter :: INO2   = 12
+  integer, parameter :: NMaxGases = 12
+
+  ! Molar masses (g mol-1) of dry air and the various gases above
+  real(jprb), parameter :: AirMolarMass = 28.970_jprb
+  real(jprb), parameter, dimension(0:NMaxGases) :: GasMolarMass = (/ &
+       & 0.0_jprb,        & ! Gas not present
+       & 18.0152833_jprb, & ! H2O
+       & 44.011_jprb,     & ! CO2
+       & 47.9982_jprb,    & ! O3
+       & 44.013_jprb,     & ! N2O
+       & 28.0101_jprb,    & ! CO
+       & 16.043_jprb,     & ! CH4
+       & 31.9988_jprb,    & ! O2
+       & 137.3686_jprb,   & ! CFC11
+       & 120.914_jprb,    & ! CFC12
+       & 86.469_jprb,     & ! HCFC22
+       & 153.823_jprb,    & ! CCl4    
+       & 46.0055_jprb /)    ! NO2
+
+  ! The corresponding names of the gases in upper and lower case, used
+  ! for reading variables from the input file
+  character*6, dimension(NMaxGases), parameter :: GasName &
+       &  = (/'H2O   ','CO2   ','O3    ','N2O   ','CO    ','CH4   ', &
+       &      'O2    ','CFC11 ','CFC12 ','HCFC22','CCl4  ','NO2   '/)
+  character*6, dimension(NMaxGases), parameter :: GasLowerCaseName &
+       &  = (/'h2o   ','co2   ','o3    ','n2o   ','co    ','ch4   ', &
+       &      'o2    ','cfc11 ','cfc12 ','hcfc22','ccl4  ','no2   '/)
+
+end module radiation_gas_constants
